<?php

##########################################################################################
# In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
#
# AUSTRALIA - http://shopmania.com.au/ (only supporting AUD, NZD datafeeds)
# ARGENTINA - http://www.shopmania.com.ar/ (only supporting ARS, EUR, USD)       *NEW
# BRASIL - http://www.shopmania.com.br/ (only supporting BRL, USD) 
# BULGARY - http://www.shopmania.bg/ (only supporting BGN, EUR, USD)
# CZECH REPUBLIC - http://www.shop-mania.cz/ (only supporting CZK, EUR, USD)		*NEW
# CHILE - http://www.shopmania.cl/ (only supporting CLP, USD, EUR)       *NEW
# CHINA - http://www.shopmania.cn/ (only supporting CNY, USD)       
# DEUTSCHLAND - http://www.shopmania.de/ (only supporting EUR, USD) 
# FRANCE - http://www.shopmania.fr/ (only supporting EUR, USD datafeeds)
# HUNGARY - http://www.shopmania.hu/ (only supporting HUF, EUR, USD datafeeds)
# INDIA - http://www.shopmania.in/ (only supporting INR, USD datafeeds)
# IRELAND - http://www.shopmania.ie/ (only supporting EUR, GBP datafeeds)
# ITALY - http://www.shopmania.it/ (only supporting EUR, USD datafeeds)
# JAPAN - http://www.shopmania.jp/  (only supporting JPY, USD datafeeds)       
# MEXICO - http://www.shopmania.com.mx/ (only supporting MXN (Mexican peso), USD, EUR datafeeds)
# NETHERLANDS - http://www.shopmania.nl/ (only supporting EUR datafeeds)		*NEW
# POLSKA - http://www.shopmania.pl/ (only supporting PLN, EUR, USD) 
# PORTUGAL - http://www.shopmania.pt/ (only supporting EUR, USD) 
# ROMANIA - http://www.shopmania.ro/ (only supporting RON, EUR, USD datafeeds)
# RUSSIA - http://www.shopmania.ru/ (only supporting RUB, EUR, USD)       
# SERBIA - http://www.shopmania.rs/ (only supporting RSD, EUR)		*NEW	
# SLOVAKIA - http://www.shop-mania.sk/ (only supporting EUR, USD)
# SOUTH AFRICA - http://www.shopmania.co.za/ (only supporting ZAR, USD, EUR)       *NEW
# SPAIN - http://www.shopmania.es/ (only supporting EUR datafeeds) 
# SWEDEN - http://www.shopmania.se/ (only supporting SEK, EUR, USD datafeeds)		*NEW
# TURKEY - http://www.shopmania.com.tr/ (only supporting TRY, EUR, USD)
# US - http://www.shopmania.com/ (only supporting USD, CAD datafeeds)
# UK - http://www.shopmania.co.uk/ (only supporting GBP, EUR, USD datafeeds)
#
# Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
# Files will be  retrieved daily from your server having the products listed automatically on ShopMania
# 
# 
# Options
# @url_param taxes=on (on,off) 
# @url_param storetaxes=on (on,off) 
# @url_param discount=on (on,off) 
# @url_param add_vat=off (on,off) 
# @url_param vat_value=24 (VAT_VALUE) 
# @url_param shipping=off (on,off) 
# @url_param add_tagging=on (on,off) 
# @url_param tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) 
# @url_param description=on (on,off) 
# @url_param image=on (on,off) 
# @url_param specialprice=on (on,off) 
# @url_param sef=off (on,off) 
# @url_param on_stock=off (on,off) 
# @url_param forcepath=off (on,off) 
# @url_param forcefolder= (FORCEFOLDER) 
#
# 
##########################################################################################

// Current datafeed script version
$script_version = "1.06";

// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed PHPMass</b> <br />";
	echo "version <b>" . $script_version . "</b><br />";
	exit;
}


if (!ini_get("safe_mode")) {
    set_time_limit(0);
}
ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);
$_SVR = array();


##### Include configuration files ################################################

// Path to configure.php file
$site_base_path = "./";

$SiteSection = 'front';
if (file_exists($site_base_path . 'includes/config.php')) {
	include ($site_base_path . 'includes/config.php');
}
else {
	echo ('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Please ensure that this file is in the root directory, or make sure the path to the directory where the config.php file is located is defined corectly above in $site_base_path variable</BODY></HTML>');
	exit();
}

if (ISINSTALLED !== true) die('SYSTEM ERROR: The script is not installed.'); //Is site installed
if (INDMSITE !== true) die('SYSTEM ERROR: Compilation failed.'); //In Site Check

####################################################################


// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |
$datafeed_currency = CURRENCY; // Please make sure that you are using the corect currency code. Possible values are RON, EUR, USD

##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$tagging_params = (@$_GET['tagging_params'] != "") ? urldecode($_GET['tagging_params']) : "utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link";
$show_description = (@$_GET['description'] == "off") ? "off" : "on";
$show_image = (@$_GET['image'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock'] == "on") ? "on" : "off";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$use_path = (@$_GET['usepath'] != "") ? $_GET['usepath'] : "";
$force_folder = (@$_GET['forcefolder'] != "") ? $_GET['forcefolder'] : "";

####################################################################


// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	
	echo "<b>Datafeed PHPMass</b> <br />";
	echo "version <b>" . $script_version . "</b><br /><br /><br />";
		
	//echo "<b>Taxes options</b> - possible values on, off default value on<br />";
	//echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	//echo "<b>Store taxes options</b> - possible values on, off default value on<br />";
	//echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	//echo "<b>Discount options</b> - possible values on, off default value on<br />";
	//echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	
	echo "<b>Add VAT to prices</b> - possible values on, off default value off<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
		
	echo "<b>VAT value</b> - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";
		
	//echo "<b>Add shipping to datafeed</b> - possible values on, off default value off<br />";
	//echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=off" . "\" >" . $script_basepath . "?shipping=off" . "</a><br /><br />";
	
	echo "<b>Add GA Tagging to product URL</b> - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
	
	echo "<b>Add custom Tagging to product URL</b> - possible values url_encode(TAGGING_PARAMS) default value tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=from%3Dshopmania" . "\" >" . $script_basepath . "?tagging_params=from%3Dshopmania" . "</a><br /><br />";
	
	echo "<b>Display Description options</b> - possible values on, off<br />";
	echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br /><br />";

	echo "<b>Display image options</b> - possible values on, off default value on<br />";
	echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	//echo "<b>Special price options</b> - possible values on, off default value on<br />";
	//echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	//echo "<b>Add basepath to product URL</b> - possible values on, off default value off<br />";
	//echo "forcepath=off (on,off) <a href=\"" . $script_basepath . "?forcepath=on" . "\" >" . $script_basepath . "?forcepath=on" . "</a><br /><br />";
	
	//echo "<b>Usepath - force defined basepath to product URL</b> - possible values ex: www.site.com<br />";
	//echo "usepath=BASEPATH <a href=\"" . $script_basepath . "?forcepath=on&usepath=www.site.com" . "\" >" . $script_basepath . "forcepath=on&usepath=www.site.com" . "</a><br /><br />";
		
	exit;
}

####################################################################


##### Extract options from database ################################################

// Get Manufacturers
$sql = "SELECT * FROM manufactures";
$DB->Query($sql,'getManufacturers');
while ($row = $DB->Fetch('getManufacturers')) {
	$MANUF_ARR[$row['manufactureid']] = array('name' => $row['manufacturename'], 'url' => $row['manufacureurl'], 'manufsite' => $row['manufsite']);
}
if ($URLRewrite) {
	if (isset($MANUF_ARR) && is_array($MANUF_ARR)) {
		foreach ($MANUF_ARR as $key=>$row) {
			$MANUF_ARR[$key] = array('name' => $row['name'], 'url' => makeRewriteURL(aplyFilterToQuery($URLRewrite,'manurl',$row['url'])), 'manufsite' => $row['manufsite']);
		}
	}
}

// Get taxes
$sql = "SELECT * FROM products_taxes";
$DB->Query($sql,'getAllTaxes');
while ($row = $DB->Fetch('getAllTaxes')){
	if ($row['type'] == 'percent') $typeCode = '%';
	else $typeCode = '$';
	$TAXES[$row['taxid']] = array('name' => $row['taxname'], 'value' => $row['value'], 'typename' => $row['type'], 'typecode' => $typeCode, 'hidden' => $row['hidden']);
}

// Get categories
$sql = "SELECT * FROM categories";
$DB->Query($sql,'getCategories');
while ($row = $DB->Fetch('getCategories')) {
	$CAT_ARR[$row['categoryid']] = array('categoryid' => $row['categoryid'],'parentid' => $row['parentid'],'url' => $row['categoryurl'], 'name'=>$row['categoryname']);
}


######################################################################


##### Print product data ####################################################

// Get Products
$sql = "SELECT * FROM products";

$DB->Query($sql,'showAllProducts');
while ($row = $DB->Fetch('showAllProducts')) {
	
	$prod_taxes = array();
	$taxes_arr = array();
	
	$taxes_arr = explode(',', $row['taxes']);
	foreach ($taxes_arr as $value){
		if (!empty($value)) { $prod_taxes[$value] = 'on'; }
	}
	
	if (!empty($TAXES) && !empty($prod_taxes) && is_array($TAXES) && is_array($prod_taxes) && $row['price'] > 0) {
	
		$tax['%'] = null;
		$tax['$'] = null;
		
		foreach ($prod_taxes as $taxid=>$isOn) {
		
			if ($TAXES[$taxid]['typecode'] == '%') $tax['%']+=$TAXES[$taxid]['value'];
			else $tax['$']+=$TAXES[$taxid]['value'];
		}
		if ($tax['$']) $row['price'] = $row['price'] - $tax['$'];
		if ($tax['%']) $row['price'] = $row['price'] / (100 + $tax['%']) * 100;		
	}
	
	$cat_name = smfeed_get_full_cat($row['categoryid'], $CAT_ARR);
	$prod_manufacturer = $MANUF_ARR[$row['manufacturer']]['name'];
	$prod_model = $row['productcode'];
	$prod_id = $row['productid'];
	$prod_name = $row['name'];
	$prod_desc = $row['details'];
	$prod_url = WEBSITE_URL . "/" . $row['producturl'] . "/";
	
	// Add GA Tagging parameters to url
	if ($add_tagging == "on") {
		$and_param = (preg_match("/\?/", $prod_url)) ? "&" : "?";
		$prod_url = $prod_url . $and_param . $tagging_params;
	}
	
	$prod_image = WEBSITE_URL . "/files/images/" . $row['image0'] . "/" . $row['productid'] . "-0-large.jpg";
	$prod_price = $row['price'];
	
	// Add VAT to prices
	if ($add_vat == "on") {
		$prod_price = $prod_price * $vat_value;
	}
	
	// Clean product name (new lines)
	$prod_name = str_replace("\n", "", strip_tags($prod_name));
	// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
	$prod_desc = smfeed_replace_not_in_tags("\n", "<BR />", $prod_desc);
	$prod_desc = str_replace("\n", " ", $prod_desc);	
	$prod_desc = str_replace("\r", "", $prod_desc);
	
	// Clean product names and descriptions (separators)
	if ($datafeed_separator == "\t") {
		$prod_name = str_replace("\t", " ", strip_tags($prod_name));
		$prod_desc = str_replace("\t", " ", $prod_desc);
		$cat_name = str_replace("\t", " ", $cat_name);
	}
	elseif ($datafeed_separator == "|") {
		$prod_name = str_replace("|", " ", strip_tags($prod_name));
		$prod_desc = str_replace("|", " ", $prod_desc);
		$cat_name = str_replace("|", " ", $cat_name);
	}
	else {
		print "Incorrect columns separator.";
		exit;			
	}
	
	// Here you can overwrite the default currency if your products are listed with different currencies
	// $datafeed_currency = $prod_currency
	
	// Required fields are: category name, merchant product ID, product name, product URL, product price
	// For the product model you should only use the manufacturer code, ISBN code or UPC code - If you are not sure about a field please leave it empty
	
	// Output the datafeed content
	print  
	$cat_name . $datafeed_separator . 
	$prod_manufacturer . $datafeed_separator . 
	$prod_model . $datafeed_separator . 
	$prod_id . $datafeed_separator . 
	$prod_name . $datafeed_separator . 
	$prod_desc . $datafeed_separator . 
	$prod_url . $datafeed_separator . 
	$prod_image . $datafeed_separator . 
	$prod_price . $datafeed_separator . 
	$datafeed_currency . "\n";
	
}


###################################################################


##### Functions ########################################################

// Function to get category with full path
function smfeed_get_full_cat($cat_id, $CATEGORY_ARR) {
	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['name'];	
	while (sizeof($CATEGORY_ARR[$item_arr['parentid']]) > 0 && is_array($CATEGORY_ARR[$item_arr['parentid']]) ) {
		
		$cat_name = $CATEGORY_ARR[$item_arr['parentid']]['name'] . " > " . $cat_name;		
		$item_arr = $CATEGORY_ARR[$item_arr['parentid']];
	}	
	return $cat_name;
}

function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

###################################################################

?>